#!/bin/sh

CLASSPATH=/usr/local/linux-sun-jdk1.4.2/WTK104/lib/midpapi.zip

if [ "$1" = "lite" ]
then
	echo Compiling OTPGen lite...
	echo Program classes
	javac -classpath $CLASSPATH -d classes -encoding PREPROC \
		-J-Dpp.defines="LITE" src/OTPGen/*.java
	PRV_SFX="-lite"
else
	echo Compiling OTPGen...
	echo Dictionary classes...
	javac -classpath $CLASSPATH -d classes -encoding PREPROC \
		src/Words/*.java
	echo Program classes...
	javac -classpath $CLASSPATH:classes -d classes -encoding PREPROC \
		src/OTPGen/*.java
	PRV_SFX=""
fi

echo Preverifying...
preverify -classpath $CLASSPATH -d preverified$PRV_SFX classes
echo Packing...
cd preverified$PRV_SFX

if [ "$1" = "lite" ]
then
	jar -cvfm ../OTPGen-lite.jar META-INF/MANIFEST.MF OTPGen about.png
else
	jar -cvfm ../OTPGen.jar META-INF/MANIFEST.MF OTPGen Words about.png
fi
cd ..
