package OTPGen;

import javax.microedition.lcdui.*;

public class Computer extends Form implements Runnable, CommandListener
{
	Display display;
	Gauge gauge;
	DisplayPassword alPassword;

	CommandListener owner;

	Account account;
	String pass;
	String title;
	Command cmCancel;

	public Computer(Display d, Account a, String p, CommandListener l) {
		super(a.getLabel());

		display = d;
		account = a;
		pass = p;
		owner = l;
		title = a.getLabel();

		gauge = new Gauge("Please wait...", false, account.getSeq(),
				0);
		cmCancel = new Command("Cancel", Command.CANCEL, 0);
		append(gauge);
//		addCommand(cmCancel);

		setCommandListener(owner);
	}

	public void run() {
		alPassword = new DisplayPassword(title,
			compute(account, pass), this);
		display.setCurrent(alPassword);
	}

	// the owner handles the ui
	public void commandAction(Command cm, Displayable d) {
		if (d == alPassword) {
			alPassword.doCommand(cm);
		}
		owner.commandAction(cm, this);
	}

	private byte[] compute(Account a, String pass) {
		HASH hash;
		byte[] init = (a.getSeed() + pass).getBytes();
		byte[] result = new byte[8];
		int i;

		if (a.getHash() == a.HASH_MD4) {
			hash = new MD4();
		} else if (a.getHash() == a.HASH_MD5) {
			hash = new MD5();
		} else if (a.getHash() == a.HASH_SHA1) {
			hash = new SHA1();
		} else {
			return new byte[]{};
		}

		// FIXME
		i = 0;
		while((init.length-i) >= 0) {	// force padding
			hash.transformBlock(init,i);
			i += 64;
		}

		result = hash.foldTo64();

		i = 0;
		while(i <= a.getSeq()) {
			hash.reset();
			hash.transformBlock(result, 0);
			result = hash.foldTo64();
			i++;
			if ((i % 10) == 0)
				gauge.setValue(i);
		}

		return result;
	}
}
