package OTPGen;

import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import javax.microedition.rms.*;

public class EditAccount extends Form
		implements ItemStateListener, doAfterCommand {
	public final static int OK = 0;
	public final static int CANCEL = -1;
	public final static int FULL = -2;
	public final static int ERROR = -3;

	CommandListener owner;
	Command cmOk, cmCancel;
	TextField tfSeed, tfSeq;
	ChoiceGroup cgFunc;
	Account account;
	
	public EditAccount(String title, CommandListener l) {
		super(title);
		owner = l;

		cmOk = new Command("Ok", Command.OK, 1);
		cmCancel = new Command("Cancel", Command.CANCEL, 2);
		tfSeed = new TextField("Seed:", "", 16, TextField.ANY);
		tfSeq = new TextField("Sequence No.:", "1", 9,
				TextField.NUMERIC);
		cgFunc = new ChoiceGroup("Hash Function:", Choice.EXCLUSIVE,
				Account.hashNames, null);


		this.addCommand(cmOk);
		this.addCommand(cmCancel);
		this.append(tfSeed);
		this.append(tfSeq);
		this.append(cgFunc);
		
		this.setCommandListener(owner);
		this.setItemStateListener(this);
	}

	public void itemStateChanged(Item item) {
		if (item == tfSeed) {
			// FIXME: validate seed (only alnum characters)
			account.setSeed(tfSeed.getString().toLowerCase());
		} else if (item == tfSeq) {
			account.setSeq(Integer.parseInt(tfSeq.getString()));
		} else if (item == cgFunc) {
			account.setHash(cgFunc.getSelectedIndex());
		}
	}

	public void setAccount(Account acc) {
		account = acc;

		tfSeed.setString(account.getSeed());
		tfSeq.setString(Integer.toString(account.getSeq()));

		cgFunc.setSelectedIndex(account.getHash(), true);
	}

	public int doCommand(Command c) {
		if (c == cmCancel) {
			return CANCEL;
		} else if (c == cmOk) {
			try {
				account.save(ListAccounts.RSNAME);
			} catch(RecordStoreFullException e) {
				return FULL;
			} catch(RecordStoreException e) {
				return ERROR;
			}
			return OK;
		}
		return 0;
	}

	public void afterCommand(Command c) {
	}
}
