package OTPGen;

import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;
import javax.microedition.rms.*;
import java.io.*;

public class OTPGen extends MIDlet implements CommandListener
{
	Display display;

	ListAccounts lsAccounts;

	EditAccount fmEdit; // = new EditAccount("Account Settings", this);
	EnterPassword fmPassword; // = new EnterPassword("Pass Phrase", this);
	Form fmAbout;
	Account acc;
	DisplayPassword alPassword;
	Computer computer;
	Thread tCompute = null;
	
	public OTPGen() {

	}

	public void startApp() {
		display = Display.getDisplay(this);
		mkLsAccounts();

		display.setCurrent(lsAccounts);
	}

	public void pauseApp() {
		lsAccounts = null;
	}

	public void commandAction(Command cm, Displayable d) {
		if (d == lsAccounts) {
			int rslt = lsAccounts.doCommand(cm);
			if (rslt == lsAccounts.EXIT) {
				lsAccounts = null;
				destroyApp(false);
				notifyDestroyed();
			} else if (rslt == lsAccounts.EDIT) {
				acc = lsAccounts.getCurrentAccount();
				if (acc != null) {
					mkFmEdit(acc);
					display.setCurrent(fmEdit);
					lsAccounts = null;
				}
			} else if (rslt == lsAccounts.ADD) {
				acc = new Account();
				if (acc != null) {
					mkFmEdit(acc);
					display.setCurrent(fmEdit);
					lsAccounts = null;
				}
			} else if (rslt == lsAccounts.COMPUTE) {
				acc = lsAccounts.getCurrentAccount();
				if (acc != null) {
					mkFmPassword(acc);
					display.setCurrent(fmPassword);
					lsAccounts = null;
				}
			} else if (rslt == lsAccounts.ABOUT) {
				fmAbout = mkFmAbout();
				if (fmAbout != null) {
					display.setCurrent(fmAbout);
				}
			}
		} else if (d == fmEdit) {
			int rslt = fmEdit.doCommand(cm);
			if (lsAccounts == null) { // should be always null
					mkLsAccounts();
			}
			if ((rslt == fmEdit.OK) || (rslt == fmEdit.CANCEL)) {
							display.setCurrent(lsAccounts);
				fmEdit = null;
			} else if (rslt == fmEdit.FULL) {
				Alert alert = new Alert("Full",
				"Record Store is full, cannot save changes.",
				null, null);
				alert.setTimeout(Alert.FOREVER);
				display.setCurrent(alert, lsAccounts);
			} else if (rslt == fmEdit.ERROR) {
				Alert alert = new Alert("Error",
				"An error has occured while saving changes.",
				null, null);
				alert.setTimeout(Alert.FOREVER);
				display.setCurrent(alert, lsAccounts);
			}
		} else if (d == fmPassword) {
			int rslt = fmPassword.doCommand(cm);
			if (rslt == fmPassword.OK) {
				String pass = fmPassword.getPassword();
		//		alPassword = new DisplayPassword(acc.getLabel(), compute(acc, pass), this);

				computer = new Computer(display, acc, pass,
					this);
				display.setCurrent(computer);
				tCompute = new Thread(computer);
				tCompute.start();

				acc.decSeq();
				try {
					acc.save(ListAccounts.RSNAME);
				}
				catch(Exception e) {
				}
				pass = null; // should I blank it? how?
				fmPassword = null;
			} else if (rslt == fmPassword.CANCEL) {
				if (lsAccounts == null) {
					mkLsAccounts();
				}
				display.setCurrent(lsAccounts);
			}
			fmPassword = null;
/*		} else if (d == alPassword) {
			int rslt = alPassword.doCommand(cm);
			if (rslt == alPassword.OK) {
				if (lsAccounts == null) {
					mkLsAccounts();
				}
				display.setCurrent(lsAccounts);
				alPassword = null;
			} */
		} else if (d == computer) {
			if (lsAccounts == null) {
				mkLsAccounts();
			}
			display.setCurrent(lsAccounts);
			computer = null;
		} else if (d == fmAbout) {
			if (lsAccounts == null) {
				mkLsAccounts();
			}
			display.setCurrent(lsAccounts);
			fmAbout = null;
		}
	}

	public void destroyApp(boolean unconditional) {
		
	}

	private void mkLsAccounts() {
		try {
			lsAccounts = new ListAccounts("OTPGen - Accounts", List.IMPLICIT, this);
		}
		catch(RecordStoreException e) {
			Alert alert = new Alert("Error", "Record Store error: "
					+ e.toString(), null, null);
			alert.setTimeout(Alert.FOREVER);
			display.setCurrent(alert, lsAccounts);
		}
	}

	private void mkFmEdit(Account a) {
		fmEdit = new EditAccount("Account Settings", this);
		fmEdit.setAccount(a);
	}

	private void mkFmPassword(Account a) {
		fmPassword = new EnterPassword(a.getLabel(), this);
	}

	private Form mkFmAbout() {
		Form fmAbout = new Form("About");
		Command cmBack;

		if (fmAbout != null) {
			try {
				ImageItem img = new ImageItem(null,
					Image.createImage("/about.png"),
					ImageItem.LAYOUT_CENTER |
					ImageItem.LAYOUT_NEWLINE_BEFORE |
					ImageItem.LAYOUT_NEWLINE_AFTER, "");
				fmAbout.append(img);
			}
			catch(IOException e) {
				fmAbout.append(
					new StringItem(null,"One-Time Password "
					+"Generator v1.0\n\n(c) 2004 by Marcin "
					+"Simonides\nhttp://marcin.studio4plus.com/en/otpgen/"));
			}

			cmBack = new Command("Back", Command.BACK, 1);
			fmAbout.addCommand(cmBack);
			fmAbout.setCommandListener(this);
		}
		return fmAbout;
	}

}
